Subject: [UFC-dev] Conventions for numbering of local dofs?

From: "Martin Sandve Alnæs" <[email-masked]>
Date: Wed, 15 Aug 2007 11:12:26 +0200

To support sub-dof maps we have agreed on a convention to let the
global dof indices of each subelement be contiguous. Thus the
assembler must do a separate renumbering step if subcomponents are to
be kept close in the global vector. This facilitates relatively easy
assembly into block matrices as well as allowing other numbering
schemes without compiling new forms, which is good (we need to keep
recompilation as rare as possible).

But if the assembler is to actually know which local dofs are to be
inserted in which global block, we must have the same numbering
convention on the local level as well.  Then the resulting element
matrix from a tabluate_tensor can be distributed to block matrices
using the sub-dof maps. Agree?

Both these conventions are only necessary if the dof_map has
num_sub_dof_maps() > 1.

-- 
Martin